#ifndef _DIO_CLIENT_H_
#define _DIO_CLIENT_H_

#include <pktIO.h>

struct reflex;

#ifdef __cplusplus
extern "C"
{
#endif
  
  struct reflexDio {
    int port;
    
    /* ---------------------------------------- */

    int (*updateRpl) (struct reflex *reflex, int rv, unsigned char id,
		      int ts, int count);
    
    int (*rptRpl)    (struct reflex *reflex, int rv, unsigned char id, int ts);
    
    int (*setRpl)    (struct reflex *reflex, int rv, unsigned char id, int ts);
    
    int (*unknownRpl) (struct reflex *reflex, unsigned char id,
		       unsigned char size,
		       unsigned char *buffer, unsigned char opcode);
    
    /* ---------------------------------------- */

    int (*update)    (struct reflex *reflex, unsigned char id, int ts,
		      unsigned char netId, unsigned char offset,
		      unsigned char state);
    
    int (*rpt)       (struct reflex *reflex, unsigned char id, int ts,
		      unsigned char netId, unsigned char offset,
		      unsigned char state);
    
    /* ---------------------------------------- */

    int (*updateReq)  (struct reflex *reflex, unsigned char id,
		       int ts);
    
    int (*rptReq)     (struct reflex *reflex, unsigned char id,
		       int period);
    
    int (*setReq)     (struct reflex *reflex, unsigned char id,
		       unsigned char netId, unsigned char offset,
		       unsigned char state, unsigned char mask);
	 
    /* ---------------------------------------- */

    int (*handlePort) (struct reflex *reflex, int size,
		       unsigned char *buffer,
		       unsigned char id, unsigned char opcode);

    int (*destroy)    (struct reflexDio *ptr);
  };

  struct reflexDio * reflexDioNew (int port);
#ifdef __cplusplus
}
#endif

#endif
